<?php
load_theme_textdomain('lb-lang', get_template_directory() . 'translations');

wp_enqueue_script('jquery');
add_action('wp_head', 'lb_teme_load_js', 9);
function lb_teme_load_js() {
	$theme_JS_path = get_bloginfo('template_url') . "/js/";
	wp_deregister_script('jquery');
	wp_register_script('jquery', $theme_JS_path . 'jquery-1.3.2.min.js', false, '1.3.2');
}

if ( function_exists('register_sidebar') ){ lb_teme_sidebars_register();}
function lb_teme_sidebars_register( $name = array('Sidebar Top', 'Sidebar Left', 'Sidebar Right', 'Single Post Sidebar', 'Footer Widget-1', 'Footer Widget-2', 'Footer Widget-3')){
	foreach ($name as $w_name){
		register_sidebar( array( 'name' => $w_name, 'before_widget' => '<div class="widget %2$s">', 'after_widget' => '</div>', 'before_title' => '<h3 class="widget-title">', 'after_title' => '</h3>',));
	}
}

function lb_teme_cover(){
	return get_option('lb_teme_cover');
}

function lb_teme_twitter(){
	return get_option('lb_teme_twitter');
}

function lb_teme_syntax_highlighter(){
	return get_option('lb_teme_syntax_highlighter');
}

function lb_teme_invalid_css(){
	return get_option('lb_teme_invalid_css');
}

function lb_teme_pngfix(){
	return get_option('lb_teme_pngfix');
}

function get_cover(){

	$read_covers = read_covers();
	$covers = $read_covers['Covers'];

	if ( in_array('default', $covers) ){

		$cover  = '<link rel="stylesheet" href="';
		$cover .=  get_bloginfo('template_url');
		$cover .= '/covers/';

		if ( false !== ($current_cover = lb_teme_cover()) ) {

			if ( $current_cover == 'random' ) {
				mt_srand((double)microtime()*1000000);
				$rand = mt_rand(0, count($covers)-1);
				if (!isset($covers[$rand])){return false;}
				$cover .= $covers[$rand];}

				else if ( in_array($current_cover, $covers) ){
					$cover .= $current_cover;}

					else{ $cover .= 'default';}

		}else{
			$cover .= 'default';}

			$cover .= '/style.css" type="text/css" media="screen" />';
			return $cover;

	}else{
		return '<!-- No valid covers found! -->';}
}

function read_cover_data( $cover_file, $cover_dir ) {
	$themes_allowed_tags = array(
		'a' => array(
			'href' => array(),'title' => array()
	),
		'abbr' => array(
			'title' => array()
	),
		'acronym' => array(
			'title' => array()
	),
		'code' => array(),
		'em' => array(),
		'strong' => array()
	);

	$cover_data = implode( '', file( $cover_file ) );
	$cover_data = str_replace ( '\r', '\n', $cover_data );

	if ( preg_match( '|Cover Name:(.*)$|mi', $cover_data, $theme_name ) )
	$name = $cover = wp_kses( _cleanup_header_comment($theme_name[1]), $themes_allowed_tags );
	else
	$name = $cover = '';

	if ( preg_match( '|Description:(.*)$|mi', $cover_data, $description ) )
	$description = wptexturize( wp_kses( _cleanup_header_comment($description[1]), $themes_allowed_tags ) );
	else
	$description = '';

	if ( preg_match( '|Author URI:(.*)$|mi', $cover_data, $author_uri ) )
	$author_uri = esc_url( _cleanup_header_comment($author_uri[1]) );
	else
	$author_uri = '';

	if ( preg_match( '|Author:(.*)$|mi', $cover_data, $author_name ) ) {
		if ( empty( $author_uri ) ) {
			$author = wp_kses( _cleanup_header_comment($author_name[1]), $themes_allowed_tags );
		} else {
			$author = sprintf( '<a href="%1$s" title="%2$s">%3$s</a>', $author_uri, __( 'Visit author homepage' ), wp_kses( _cleanup_header_comment($author_name[1]), $themes_allowed_tags ) );
		}
	} else {
		$author = __('Anonymous');
	}

	return array( 'Name' => $name, 'Description' => $description, 'Author' => $author, 'Folder' => $cover_dir );
}

function read_covers(){

	$folder = '/covers';

	$folder = get_template_directory() . trim($folder);
	$folder = ($folder == '') ? './' : $folder;

	if (!is_dir($folder)){ return false; }

	$covers = array();
	$cover_data = array();
	if ($dir = @opendir($folder)){
		while($cover_dir = readdir($dir)){
			if (!preg_match('<[.]>', $cover_dir)){
				if ($c_d = @opendir($folder . '/' . $cover_dir)){
					while($cover_files = readdir($c_d)){
						if ($cover_files == 'style.css'){
							$covers[] = $cover_dir;
							$cover_data[] = read_cover_data($folder . '/' . $cover_dir . '/style.css', $cover_dir);
						}
					}
					closedir($c_d);
				}else{
					break;
				}
			}
		}
		closedir($dir);
	}else{
		break;
	}

	if (count($covers) == 0){
		return false;
	}else{
		return array( 'Covers' => $covers, 'CoverData' => $cover_data);
	}
}

add_action('admin_menu', 'lb_theme_admin');

function lb_theme_admin() {

	function message_for_admin($msg){
		$msg = trim($msg);
		if ( $msg == ''){
			$msg = '';
		}else{
			$msg = preg_replace('/\s/', '_', $msg);
			$msg = '&msg=' . $msg;
		}
		return $msg;
	}

	if ( isset( $_GET['page'] ) && $_GET['page'] == basename(__FILE__) ) {
		if ( isset( $_REQUEST['action'] ) && 'save' == $_REQUEST['action'] ) {
			check_admin_referer('lb_teme_settings');

			
			
			if ( isset($_REQUEST['lb_teme_cover_save']) && '' !== ( $lb_teme_cover_name = trim($_REQUEST['lb_teme_cover_name']) ) ) {
				update_option('lb_teme_cover', $lb_teme_cover_name);
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_cover_random']) ) {
				update_option('lb_teme_cover', 'random');
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_cover_default']) ) {
				delete_option('lb_teme_cover');
				//$msg = __('', 'lb-lang');
			}
			
			
			
			else if (isset($_REQUEST['lb_teme_twitter_save']) && '' !== ( $lb_teme_twitter_name = trim($_REQUEST['lb_teme_twitter_name']) )){
				update_option('lb_teme_twitter', $lb_teme_twitter_name);
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_twitter_delete']) ) {
				delete_option('lb_teme_twitter');
				//$msg = __('', 'lb-lang');
			}
			
			
			
			else if ( isset($_REQUEST['lb_teme_syntax_highlighter_true']) ) {
				update_option('lb_teme_syntax_highlighter', 'true');
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_syntax_highlighter_false']) ) {
				delete_option('lb_teme_syntax_highlighter');
				//$msg = __('', 'lb-lang');
			}
			
			
			
			else if ( isset($_REQUEST['lb_teme_pngfix_off']) ) {
				update_option('lb_teme_pngfix', 'off');
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_pngfix_run']) ) {
				delete_option('lb_teme_pngfix');
				//$msg = __('', 'lb-lang');
			}
			
			
			
			else if ( isset($_REQUEST['lb_teme_invalid_css_true']) ) {
				update_option('lb_teme_invalid_css', 'true');
				//$msg = __('', 'lb-lang');
			}
			else if ( isset($_REQUEST['lb_teme_invalid_css_false']) ) {
				delete_option('lb_teme_invalid_css');
				//$msg = __('', 'lb-lang');
			}
			
			else if ( isset($_REQUEST['lb_teme_settings_delete']) ) {
				delete_option('lb_teme_cover');
				delete_option('lb_teme_twitter');
				delete_option('lb_teme_syntax_highlighter');
				delete_option('lb_teme_pngfix');
				delete_option('lb_teme_invalid_css');
				$msg = __('All settings removed correctly', 'lb-lang');
			}
			else{
				wp_redirect("themes.php?page=functions.php&saved=false" . message_for_admin($msg));
				die;
			}

			wp_redirect("themes.php?page=functions.php&saved=true" . message_for_admin($msg));
			die;
		}
	}

	add_action('admin_head', 'lb_teme_admin_page_head');
	add_theme_page(__('Edit my Mint!'), __('Edit my Mint!'), 'edit_themes', basename(__FILE__), 'lb_teme_admin_page');
}

function lb_teme_admin_page_head() {
	$output = '<link rel="stylesheet" href="' . get_bloginfo('template_url') . '/admin/style.css" type="text/css" media="screen" />';
	echo $output;
}

function lb_teme_admin_page() {
	require_once get_template_directory() . '/admin/page.php';
}

function lbComments($comment, $args, $depth){
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class('clearfix'); ?> id="comment-<?php comment_ID(); ?>">
		<div class="comment-wrapp iicols-d">
			
			<div class="colleft-d">
				<div class="comment-meta">
					<?php edit_comment_link(__('Edit comment', 'lb-lang'),'  ','') ?>
					<span class="comment-autor"><?php echo get_comment_author_link(); ?></span>
					<span class="avatar clearfix"><?php echo get_avatar( $comment, $size='50', get_bloginfo('template_url')."/images/avatars/1.png" ); ?></span>
				</div>
			</div>
			
			<div class="colright-d">
				<div class="the-comment">
					<?php if ($comment->comment_approved == '0') : ?>
					<em><?php _e('Your comment is awaiting moderation.', 'lb-lang') ?></em>
					<?php endif; comment_text(); ?>	
				</div>
				<div class="comment-meta b">
					<span class="comment-date"><?php echo get_comment_date(); ?></span>
					<span class="comment-reply"><?php $replyto = __('Reply to this comment', 'lb-lang'); comment_reply_link(array_merge( $args, array('reply_text' => $replyto, 'depth' => $depth, 'max_depth' => $args['max_depth']))); ?></span>
				</div>
			</div>
				
		</div>
<?php
}

function recentComments($comm_num, $comm_length, $replacer){
	$comments = get_comments('status=approve&order=DESC&number=' . $comm_num);
	$output =  '<h3 class="widget-title">' . __('Recent Comments', 'lb-lang') . '</h3>';
	$output .= '<ul>';
	foreach( $comments as $comm ) {
		$output .= '<li><a class="comm-content" href="' . get_permalink($comm->comment_post_ID) . '#comment-' . $comm->comment_ID . '" title="' . get_permalink($comm->comment_post_ID) . '">';
		$output .= wordCutter(strip_tags($comm->comment_content), $comm_length, $replacer);
		$output .= '</a><span class="comm-meta">' . commentedWhen($comm->comment_date) . __(' By ', 'lb-lang');
		if ($comm->comment_author_url !== ''){$output .= '<a class="url" href="' . $comm->comment_author_url . '" title="' . $comm->comment_author . '">' . $comm->comment_author . '</a></span></li>';}
		else{$output .= $comm->comment_author . '</span></li>';}
	}
	$output .= '</ul>';
	return $output;
}

function wordCutter($string, $length, $replacer){
	return (preg_match('/^(.*)\W.*$/', substr($string, 0, $length+1), $matches) ? $matches[1] : substr($string, 0, $length)) . $replacer;
}

add_filter('the_content','no_image_hacker', 1, 2);
function no_image_hacker($post){
	if ( is_category() || is_tag() || is_day() || is_month() || is_year() || is_author() ) {
		$post = preg_replace('/^<div class=\"wp\-caption[^>]+\>*<\/div>$/', '', $post);
		$post = preg_replace('/<img[^>]+\>/i', '', $post);
	}
	return $post;
}

function commentedWhen($comm_date){
	$now_date = time();
	$comment_date = strtotime($comm_date);

	if ($now_date - 3601 <= $comment_date){
		return __('Moments Ago', 'lb-lang');
	}else if ($now_date - ( 3600 * 24 ) <= $comment_date - 3600){
		return __('Today', 'lb-lang');
	}else{
		return strftime( __('%B %d, %Y', 'lb-lang'), strtotime($comm_date) );
	}
}

add_action('wp_head', 'syntax_highlighter_css', 9);
function syntax_highlighter_css() {
	if( false !== lb_teme_syntax_highlighter() ){
		$template_url = get_bloginfo('template_url');
		$stylesheet = '<link rel="stylesheet" href="' . $template_url . '/css/syntaxhighlighter.css" type="text/css" media="screen" />';
		echo $stylesheet;
	}else{
		return false;
	}
}

add_action('wp_head', 'run_invalid_css', 9);
function run_invalid_css() {
	if( false !== lb_teme_invalid_css() ){
		$template_url = get_bloginfo('template_url');
		$stylesheet = '<link rel="stylesheet" href="' . $template_url . '/css/invalid.css" type="text/css" media="screen" />';
		echo $stylesheet;
	}else{
		return false;
	}
}

function syntaxHighlighter(){
	if( false !== lb_teme_syntax_highlighter() ){
		$template_url = get_bloginfo('template_url');
		$script = '<script src="' . $template_url . '/js/shCore.js" type="text/javascript" ></script>';
		$script .= '<script src="' . $template_url . '/js/shBrushes.js" type="text/javascript" ></script>';
		$script .= '<script type="text/javascript">SyntaxHighlighter.config.clipboardSwf = "' . $template_url . '/flash/clipboard.swf"; SyntaxHighlighter.defaults[\'toolbar\'] = false; SyntaxHighlighter.all();</script>';
		return $script;
	}else{
		return false;
	}
}

function pngFix(){
	if( false == lb_teme_pngfix() ){
		$template_url = get_bloginfo('template_url');
		$behavior = '\'behavior: url(' . $template_url . '/js/iepngfix_v2/iepngfix.php)\');' . "\n";
		
		$script = '<!--[if IE 6]>' . "\n";
		$script .= '<script src="' . $template_url . '/js/iepngfix_v2/iepngfix_tilebg.js" type="text/javascript" ></script>' . "\n";
		$script .= '<script type="text/javascript">//<![CDATA[' . "\n";
		$script .= 'if (document.all && /MSIE (5\.5|6)/.test(navigator.userAgent) && document.styleSheets && document.styleSheets[0] && document.styleSheets[0].addRule){' . "\n";
		$script .= 'document.styleSheets[0].addRule(\'#cover\', ' . $behavior;
		$script .= 'document.styleSheets[0].addRule(\'.lnk\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'.comments\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'.tags-bttn\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'.cat-item a\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'input\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'textarea\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'.mint a\', ' . $behavior ;
		$script .= 'document.styleSheets[0].addRule(\'.mint-big\', ' . $behavior ;
		$script .= '}//]]></script>' . "\n";
		$script .= '<![endif]-->' . "\n";

		return $script;
	}else{
		return false;
	}
}
